Ruby: pm_def_node Struct Reference

Ruby 4.0.6p0 (2026-07-14 revision 03b6d3f8898a28604fe6cb00eae3226b821168f4)

Data Fields
pm_def_node Struct Reference

DefNode. More...

`#include <ast.h>`

## Data Fields
pm_node_t | base
| The embedded base node.
pm_constant_id_t | name
| DefNode#name.
pm_location_t | name_loc
| DefNode#name_loc.
struct pm_node * | receiver
| DefNode#receiver.
struct pm_parameters_node * | parameters
| DefNode#parameters.
struct pm_node * | body
| DefNode#body.
pm_constant_id_list_t | locals
| DefNode#locals.
pm_location_t | def_keyword_loc
| DefNode#def_keyword_loc.
pm_location_t | operator_loc
| DefNode#operator_loc.
pm_location_t | lparen_loc
| DefNode#lparen_loc.
pm_location_t | rparen_loc
| DefNode#rparen_loc.
pm_location_t | equal_loc
| DefNode#equal_loc.
pm_location_t | end_keyword_loc
| DefNode#end_keyword_loc.
Data Fields inherited from pm_node
pm_node_type_t | type
| This represents the type of the node.
pm_node_flags_t | flags
| This represents any flags on the node.
uint32_t | node_id
| The unique identifier for this node, which is deterministic based on the source.
pm_location_t | location
| This is the location of the node in the source.

## Detailed Description

DefNode.

Represents a method definition.

    def method
    end
    ^^^^^^^^^^

Type: ::PM_DEF_NODE

Definition at line 3557 of file ast.h.

## Field Documentation

## ◆ base

pm_node_t pm_def_node::base

The embedded base node.

Definition at line 3559 of file ast.h.

Referenced by pm_dump_json().

## ◆ body

struct pm_node* pm_def_node::body

DefNode#body.

Definition at line 3585 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ def_keyword_loc

pm_location_t pm_def_node::def_keyword_loc

DefNode#def_keyword_loc.

Definition at line 3595 of file ast.h.

Referenced by pm_dump_json().

## ◆ end_keyword_loc

pm_location_t pm_def_node::end_keyword_loc

DefNode#end_keyword_loc.

Definition at line 3620 of file ast.h.

Referenced by pm_dump_json().

## ◆ equal_loc

pm_location_t pm_def_node::equal_loc

DefNode#equal_loc.

Definition at line 3615 of file ast.h.

Referenced by pm_dump_json().

## ◆ locals

pm_constant_id_list_t pm_def_node::locals

DefNode#locals.

Definition at line 3590 of file ast.h.

Referenced by pm_dump_json(), and pm_node_destroy().

## ◆ lparen_loc

pm_location_t pm_def_node::lparen_loc

DefNode#lparen_loc.

Definition at line 3605 of file ast.h.

Referenced by pm_dump_json().

## ◆ name

pm_constant_id_t pm_def_node::name

DefNode#name.

Definition at line 3565 of file ast.h.

Referenced by pm_dump_json().

## ◆ name_loc

pm_location_t pm_def_node::name_loc

DefNode#name_loc.

Definition at line 3570 of file ast.h.

Referenced by pm_dump_json().

## ◆ operator_loc

pm_location_t pm_def_node::operator_loc

DefNode#operator_loc.

Definition at line 3600 of file ast.h.

Referenced by pm_dump_json().

## ◆ parameters

struct pm_parameters_node* pm_def_node::parameters

DefNode#parameters.

Definition at line 3580 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ receiver

struct pm_node* pm_def_node::receiver

DefNode#receiver.

Definition at line 3575 of file ast.h.

Referenced by pm_dump_json(), pm_node_destroy(), and pm_visit_child_nodes().

## ◆ rparen_loc

pm_location_t pm_def_node::rparen_loc

DefNode#rparen_loc.

Definition at line 3610 of file ast.h.

Referenced by pm_dump_json().

The documentation for this struct was generated from the following file:

- prism/ast.h